import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"vscode-postgres","displayName":"PostgreSQL","description":"PostgreSQL Management Tool","version":"1.4.3","publisher":"ckolkman","license":"MIT","repository":{"type":"git","url":"https://github.com/Borvik/vscode-postgres.git"},"engines":{"vscode":"^1.63.0"},"categories":["Other"],"contributes":{"languages":[{"id":"postgres","extensions":[".pgsql",".psql"],"aliases":["Postgres"],"configuration":"./language-configuration.json"}],"grammars":[{"language":"postgres","scopeName":"source.pgsql","path":"./syntaxes/pgsql.tmLanguage"}],"configuration":{"type":"object","title":"PostgreSQL","properties":{"vscode-postgres.defaultConnection":{"type":"string","default":"","description":"The default connection to use"},"vscode-postgres.defaultDatabase":{"type":"string","default":"","description":"The default database on the default connection to use"},"vscode-postgres.showExplorer":{"type":"boolean","default":true,"description":"Show or hide the database explorer."},"vscode-postgres.prettyPrintJSONfields":{"type":"boolean","default":false,"description":"Turns on/off pretty printing of JSON fields"},"vscode-postgres.setConnectionFromExplorer":{"type":"string","enum":["always","ifunset","never"],"default":"always","description":"Controls whether selecting a database in explorer changes the current editor's connection"},"vscode-postgres.tableColumnSortOrder":{"type":"string","enum":["db-order","alpha","reverse-alpha"],"default":"db-order","description":"Controls the order of the columns in the database explorer. Default is db-order which orders the columns as the were added to the table (how postgres reports them)"},"vscode-postgres.intervalFormat":{"type":"string","enum":["iso_8601","humanize","succinct"],"default":"iso_8601","description":"Controls the display format for `interval` columns. Default is the iso_8601 standard which does not cover milliseconds."},"vscode-postgres.virtualFolders":{"type":"array","default":["functions"],"description":"Controls virtual folders that are shown under schema. Currently only functions are supported."}}},"submenus":[{"id":"postgres.select","label":"Select..."}]}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('README.md', new URL('../assets/ckolkman.vscode-postgres-1.4.3.vsix/README.md', import.meta.url).href, {"mimeType":"text/markdown","size":5505});

registerFileUrl('CHANGELOG.md', new URL('../assets/ckolkman.vscode-postgres-1.4.3.vsix/CHANGELOG.md', import.meta.url).href, {"mimeType":"text/markdown","size":8927});

registerFileUrl('syntaxes/pgsql.tmLanguage', new URL('../assets/ckolkman.vscode-postgres-1.4.3.vsix/pgsql.tmLanguage', import.meta.url).href, {"size":13432});

registerFileUrl('language-configuration.json', new URL('../assets/ckolkman.vscode-postgres-1.4.3.vsix/language-configuration.json', import.meta.url).href, {"mimeType":"application/json","size":559});

registerFileUrl('package.json', new URL('../assets/ckolkman.vscode-postgres-1.4.3.vsix/package.json', import.meta.url).href, {"mimeType":"application/json","size":13991});

export { whenReady };
